/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "frog.hh"
#include <signal.h>
#include "PConfig.h"
#include <unistd.h>

using namespace std;

//======================================  Asynchronous shell command execution.
int
frog(const string& s) {
#if defined (P__DARWIN)
    sigignore(SIGCHLD);
#else
    sigignore(SIGCLD);
#endif

    pid_t pid = fork();
    if (pid != 0) {
        if (pid == -1) perror("fork failed");
        else           pid = 0;
        return pid;
    }
    string a(s);
    a += char(0);
    const char* argv[32];
    argv[0] = 0;
    char* p = &a[0];
    for (int i=0; i<31 && *p; ) {
        while (*p == ' ') *p++ = 0;
        if (*p) argv[i] = p;
        while (*p && *p != ' ') p++;
        argv[++i] = 0;
    }
    exit(execvp(argv[0], const_cast<char* const*>(argv)));
}
